



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>for循环中嵌套setTimeout，执行顺序和结果该如何理解？</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">for循环中嵌套setTimeout，执行顺序和结果该如何理解？</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 12:34:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这两天在捣鼓作用域的问题，有的时候知识这个东西真的有点像是牵一发而动全身的感觉。在理解作用域的时候，又看到了一道经典的面试题和例子题。</p>
<p>那就是在for循环中嵌套setTimeout延时，想想之前面试的时候面试官问到我这个问题，然而我当时对这玩意儿根本没有深究，没有去理解；非常草率的回答了，面试官好心的给我</p>
<p>说这个涉及到setTimeout回调函数异步特性，啪啦啪啦，说的好几句都感觉晕乎了~也感觉JS这个东西真的需要深入的东西还很多，路也还很长。</p>
<p>直接进入主题了，先贴一段简单的代码：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1156795/201708/1156795-20170817112508678-478196794.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1156795/201708/1156795-20170817112543693-1013076603.png" /></p>
<p>结果是10次10。不得不说看到答案的第一眼真的魔怔啊，完全不理解为什么是10次10；只有你多去了解JS的执行机制之后，或许心中就有答案了。所以以下是我个人在看了众多的</p>
<p>网上的各位高手的见解之后，总结以下得到的一个见解。如有歧义，欢迎各位的指正。</p>
<p>首先这样的结果需要从JS的执行机制说起。JS是单线程环境，也就是说代码的执行是从上到下，依次执行。这样的执行称为同步执行。因为种种不要浪费和节约的原因。JS中引进了异步的机制。在这段代码中，哪个是同步哪个是异步呢？for循环是同步代码，而setTimeout中的是异步代码。那么JS碰到这个有同步和异步的情况下会先从上到下执行同步代码，碰到异步的代码会将其插入到任务队列当中等待。而setTimeout是延时，也就是说碰到setTimeout这个异步的代码块会根据它里面的第二个参数：延时时间来将代码插入到任务队列当中，比如上面这段代码中，第二个参数延时时间是0，也就是说执行到它的时候会在0ms之后将它插入到任务队列当中。同步代码都执行完成之后，那么JS引擎就空闲了，这个时候就轮到任务队列中的异步代码依次加载了。</p>
<p>这是上面这段代码的答案的一半。另一半就来自于作用域，作用域是变量等资源的作用范围。在这段代码中准确的说是作用域链的问题，当同步代码执行完毕开始执行异步的setTimeout代码时，setTimeout中需要一个变量 ---i---,而执行的时候在当前的作用域中开始找，找不到变量i的定义，这个时候就把创建这个函数的作用域作为当前作用域，再次寻找，创建这个函数的作用域就是全局作用域，也就是找到了for循环中i，找到了之后就结束寻找变量i的行程。由于这个时候的i是全局的，而且人家已经变为了最终形态：10，setTimeout找到的就是这个i=10；所以就输出了10，下面的9次setTimeout 的执行都是类似，所以结果都是10；</p>
<p>所以我对这个答案的理解归结起来就是 &nbsp;异步加载+作用域链。可见要理解一段看似简单的代码，要去学习的东西还真不少。</p>
<p>问题出来了，相应的就有解决方案；对于这类问题比较常见的解决方法就是<strong> 立即执行函数。</strong>它逼迫js每次循环进来的时候都会立即去执行代码，从而保证了每一次得到了i的副本都是不一样的。贴代码：</p>
<p><strong><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1156795/201708/1156795-20170817114841115-2085869790.png" /></strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1156795/201708/1156795-20170817114853959-856283207.png" /></p>
<p>如上图，得到了想要的答案</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2nw5vq.html">Web 安全测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kywy39.html">锋利的jQuery-7--编写插件基础知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn3exx9.html">activity切换时的overridePendingTransition动画效 （转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xdg6g9.html">ajax 瀑布流实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmdkml9.html">【转】C&num;之继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1xonx9.html">关于git的cherry-pick命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0421eq.html">server 2008 ftp  环境重点说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z3rx09.html">在QLabel上点击获得的效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdogn78.html">hdu 4740 The Donkey of Gui Zhou（dfs模拟好题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ydz1n8.html">iOS 插件化开发汇总 Small框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd3zvy9.html">字符串距离 简单DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjo5m28.html">Hybrid App&mdash;Hybrid App开发模式介绍和各种开发模式对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz5jzg8.html">获取电脑系统唯一GUID</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojme61q.html">IDEA环境下SSM整合------注解开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpmo17q.html">&star; &lbrack;NOI2014&rsqb; 魔法森林 「LCT动态维护最小生成树」</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyk4ex9.html">while 循环，存储过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv20vk8.html">IScroll在某些手机浏览器上不能滑动和卡顿解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25nkk3q.html">过时date&period;toLocaleString&lpar;&rpar;的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j27r0q.html">Exception in thread &amp;quot&semi;main&amp;quot&semi; java&period;lang&period;NoSuchMethodError&colon; scala&period;Predef&dollar;&period;refArrayOps&lpar;&lbrack;Ljava&sol;lang&sol;Object&semi;&rpar;Lscala&sol;collection&sol;mutable&sol;ArrayOps&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rox048.html">高性能Javascript&lpar;1&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxd0woj9.html">django基础之二</a>
			</li>
						<li><a href="https://www.batexi.com/a/q257d6xq.html">java 简单认识移位运算符和位运算符</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllze2kq.html">5&lowbar;Python OOP</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvrm7g8.html">Docker三剑客之Docker Swarm</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyev1mq.html">Ehcache的视频-如何用Ehcache提升你的Java应用性能</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv7oxl8.html">详解C&num;泛型（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyye2jgq.html">redis集群环境的搭建和错误分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5jymmq.html">linux开机自启动设置，自定义开机启动模版，nginx开机自启动服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2gzgo9.html">ABP框架源码中的Linq扩展方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllz5jxq.html">DDA&comma; Bresenham line&amp;&num;39&semi;s algorithm and Voxel Traversal used in the Grid-Accelerator in PBRT</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
